﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace demo
{
	public class CustomRadTreeViewItem : RadTreeViewItem
	{
		protected override void OnKeyDown(KeyEventArgs e)
		{
			//*******Here goes the custom logic of template changing********//
			var myItemDataContext = this.DataContext as MyItem;
			if (myItemDataContext != null)
			{
				this.HeaderEditTemplate = myItemDataContext.SAspect != null ?	 
					App.Current.Resources["withAspect"] as DataTemplate :
					App.Current.Resources["basic"] as DataTemplate;
			}
			//**************************************************************//
			base.OnKeyDown(e);
		}
	}
}
