﻿using System;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using Telerik.Windows.Controls;

namespace demo
{
	public partial class MainPage : UserControl
	{
		public ObservableCollection<MyItem> C = new ObservableCollection<MyItem>();
		protected MyItem mi;

		public MainPage()
		{
			this.InitializeComponent();
			
			this.mi = new MyItem();
			this.mi.Name = "test name";
			this.C.Add(this.mi);
			this.DataContext = this.C;
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			this.mi.SAspect = new Aspect();
			this.mi.SAspect.SProperty = "aspect value";
		}
	}

	public class MyItem : ViewModelBase
	{
		private string name;
		private Aspect sAspect;
		private ObservableCollection<MyItem> children;

		public string Name
		{
			get
			{
				return this.name;
			}
			set
			{
				if (this.name != value)
				{
					this.name = value;
					this.NotifyPropertyChanged("Name");
				}
			}
		}

		public Aspect SAspect
		{
			get
			{
				return this.sAspect;
			}
			set
			{
				if (this.sAspect != value)
				{
					this.sAspect = value;
					this.NotifyPropertyChanged("SAspect");
				}
			}
		}

		public ObservableCollection<MyItem> Children
		{
			get
			{
				if (this.children == null)
				{
					this.children = new ObservableCollection<MyItem>();
				}
				return this.children;
			}
			set
			{
				if (this.children != value)
				{
					this.children = value;
					this.NotifyPropertyChanged("Children");
				}
			}
		}
	}
}